#include <stdio.h>  // standardne ulazno, izlazne funkcije
#include <stdlib.h> // dodatne C-funkcije
#include <math.h>   // dodatne matematicke funkcije

#include "nrutil.c" // klase za rezervaciju memorije, NR-funkcije (potreban nrutil.h)
#include "ludcmp.c" // NR-funkcije koje rade LU-dekompoziciju matrice
#include "lubksb.c" // NR-funkcija koja rjesava sustav m linearnih jednadzbi

#define MAXSTR 80   // Maksimalna duljina stringa

int main(void)
{
  int i, j, k, l, m, n, *indx, *jndx, ir;
  float p, det, *x, **a, **b, **c, **au, **al, **lu, **ax, *col, **ai, **ia;
  char tekst[MAXSTR];
  FILE *fin, *fout;

  // ZAD: UCITAJTE DIMENZIJE SUSTAVA (red matrice A = n)


  // ZAD: kreirajte potrebna polja
  indx=ivector(1,n);    // Cjelobrojni vektor za pohranu permutacija redaka
  jndx=ivector(1,n);    // Cjelobrojni vektor za preslagati permutirane redake
  x=vector(1,n);        // Realni vektor za pohranu nepoznanica (rjesenja)
  a=matrix(1,n,1,n);    // Ulazna matrica A (linearni koeficijenti)
  b=matrix(1,n,1,n);    // Ulazna matrica B (slobodni koeficijenti)
  c=matrix(1,n,1,n);    // Pomocna matrica C (sadrzi elemente od L i U)
  ai=matrix(1,n,1,n);   // Inverzna matrica od A
  al=matrix(1,n,1,n);   // Dolnja trokutasta matrica L
  au=matrix(1,n,1,n);   // Gornja trokutasta matrica U



  // ZAD: napravite duplikate za kasniju provjeru




/* ************************************************************************** */
/* ******************* LU DEKOMPOZICIJA matrice C=A ************************* */
  // Ulazni elementi:  c    = matrica koju rastavljamo C=L*U
  //                   n    = dimenzija ulazne matrice
  //                   indx = vektor za biljezenje permutacija redaka
  //                   &p   = adresa varijable za pohranu permutacija
  ludcmp(c,n,indx,&p);
  // Izlazni elementi: c    = U: dijagonala i elementi iznad u C, ostali 0
  //                          L: 1 na dijagonali, elementi ispod iz C, ostatli 0
  //                   n    = ostaje nepromijenjen
  //                   indx = vektor koji sadrzi permutacije redaka
  //                   p    = +1 za paran broj izmjena redaka, -1 za neparan


  // ZAD: Izdvojite matrice U(gornje trokutastu, au) i L(donje trokutastu, al) */


  // ZAD: Pohranite matrice L i U u izlaznoj datoteci


  // ZAD: provjerite ispravnost dekompozicije racunanjem L*U, pazite na indx
  // NAPOMENA: jndx koristite u vlastitom kodu - poslozeni brojevi pocetnih redaka
  //           indx koristite u NR funkcijama - brojevi redaka prilagodjeni NR 'jeziku'
  for (k=1;k<=n;k++) jndx[k]=k;
  for (k=1;k<=n;k++) {
    ir=jndx[indx[k]];       // Prolalazenje odgovarajucih redaka zbog
    jndx[indx[k]]=jndx[k];  // permutiranosti indeksa redaka kako bi
    jndx[k]=ir;             // lakse usporedili umnozak LU i matricu A
  }



/* ************************************************************************** */
/* ******************* Rjesavanje sustava AX = LUX = B ********************** */

   //ZAD: inicijalizirajte potrebni vektor (x)


    // Ulazni elementi:  c    = matrica koju je vratila ludcmp (LU)
    //                   n    = red ulazne matrice
    //                   indx = permutacije koje je vratila ludcmp
    //                   x    = slobodni koeficijenti (B)
    lubksb(c,n,indx,x);
    // Izlazni elementi: c    = ostaje nepromijenjen
    //                   n    = ostaje nepromijenjen
    //                   indx = ostaje nepromijenjen
    //                   x    = rjesenja sustava A*X=B
 
    // ZAD: ispisite rjesenja u izlaznu datoteku
    



    // ZAD: izracunajte determinantu




  return 0;
}
